require 'model'

class App
  attr_accessor :user, :records
  
  def initialize
    @case_records = []
  end

  def current_record
    @case_records.last
  end

  def current_visit
    current_record.visits.last
  end

  def current_audit
    current_record.audits.last
  end

  # Actions taken on behalf of a user. The app's interface.

  def login(user, password)
    @user = user
    :main_page
  end

  def new_case
    :gather_case_input_page
  end
  
  def record_case(client, clinic_id)
    @case_records << CaseRecord.new
    current_record.client = client
    current_record.clinic_id = clinic_id
    :case_display_page
  end

  def add_visit
    :gather_visit_input_page
  end

  def record_visit(diagnosis, charges, optional_fields = {})
    current_record.visits << Visit.new
    current_visit.diagnosis = diagnosis
    current_visit.charges = charges
    current_visit.comments = optional_fields['comments']
    :case_display_page
  end

  def add_audit
    :gather_audit_input_page
  end

  def record_audit(auditor, variance)
    current_record.audits << Audit.new
    current_audit.auditor = auditor
    current_audit.variance = variance
    :case_display_page
  end
  
end
